test-all.sh 16.1 KB
Newer Older
sangshuduo's avatar
sangshuduo 已提交
1 2
#!/bin/bash

3 4 5 6 7 8
# Color setting
RED='\033[0;31m'
GREEN='\033[1;32m'
GREEN_DARK='\033[0;32m'
GREEN_UNDERLINE='\033[4;32m'
NC='\033[0m'
L
liuyq-617 已提交
9

10 11 12
tests_dir=`pwd`
IN_TDINTERNAL="community"

P
Ping Xiao 已提交
13 14
function stopTaosd {
	echo "Stop taosd"
P
Ping Xiao 已提交
15
  sudo systemctl stop taosd
P
Ping Xiao 已提交
16 17 18 19 20 21 22 23 24
  PID=`ps -ef|grep -w taosd | grep -v grep | awk '{print $2}'`
	while [ -n "$PID" ]
	do
    pkill -TERM -x taosd
    sleep 1
  	PID=`ps -ef|grep -w taosd | grep -v grep | awk '{print $2}'`
	done
}

L
liuyq-617 已提交
25 26
function dohavecore(){
  corefile=`find $corepath -mmin 1`  
L
liuyq-617 已提交
27
  core_file=`echo $corefile|cut -d " " -f2`
L
liuyq-617 已提交
28
  proc=`echo $corefile|cut -d "_" -f3`
L
liuyq-617 已提交
29
  if [ -n "$corefile" ];then
30
    echo 'taosd or taos has generated core'
L
fix  
liuyq-617 已提交
31
    rm case.log
L
liuyq-617 已提交
32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47
    if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]] && [[ $1 == 1 ]]; then
      cd ../../../
      tar -zcPf $corepath'taos_'`date "+%Y_%m_%d_%H_%M_%S"`.tar.gz debug/build/bin/taosd debug/build/bin/tsim debug/build/lib/libtaos*so*
      if [[ $2 == 1 ]];then
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S"`
      else
        cd community
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
      fi
    else 
      cd ../../
      if [[ $1 == 1 ]];then 
        tar -zcPf $corepath'taos_'`date "+%Y_%m_%d_%H_%M_%S"`.tar.gz debug/build/bin/taosd debug/build/bin/tsim debug/build/lib/libtaos*so*
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
      fi
    fi
48
    if [[ $1 == 1 ]];then
L
liuyq-617 已提交
49
      echo '\n'|gdb /usr/local/taos/bin/$proc $core_file -ex "bt 10" -ex quit
50 51
      exit 8
    fi
L
liuyq-617 已提交
52
  fi
53
}
L
liuyq-617 已提交
54

55 56
function runSimCaseOneByOne {
  while read -r line; do
P
Ping Xiao 已提交
57
    if [[ $line =~ ^./test.sh* ]] || [[ $line =~ ^run* ]]; then
58
			case=`echo $line | grep sim$ |awk '{print $NF}'`    
P
Ping Xiao 已提交
59
      start_time=`date +%s`      
P
Ping Xiao 已提交
60
      date +%F\ %T | tee -a out.log
L
liuyq-617 已提交
61 62 63
      if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
        echo -n $case
        ./test.sh -f $case > /dev/null 2>&1 && \
L
liuyq-617 已提交
64
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
65 66 67 68 69
        ( grep -q 'script.*success.*m$' ../../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
        echo -e "${RED} failed${NC}" | tee -a out.log
      else
        echo -n $case
        ./test.sh -f $case > /dev/null 2>&1 && \
L
liuyq-617 已提交
70
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
71 72 73
        ( grep -q 'script.*success.*m$' ../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
        echo -e "${RED} failed${NC}" | tee -a out.log
      fi
L
liuyq-617 已提交
74
      out_log=`tail -1 out.log  `
L
liuyq-617 已提交
75 76 77
      # if [[ $out_log =~ 'failed' ]];then
      #   exit 8
      # fi
S
Shuduo Sang 已提交
78 79
      end_time=`date +%s`
      echo execution time of $case was `expr $end_time - $start_time`s. | tee -a out.log
80 81 82
    fi
  done < $1
}
83

L
liuyq-617 已提交
84
function runSimCaseOneByOnefq {
L
liuyq-617 已提交
85 86 87 88 89

  start=`sed -n "/$1-start/=" jenkins/basic.txt`
  end=`sed -n "/$1-end/=" jenkins/basic.txt`  
  for ((i=$start;i<=$end;i++)) ; do
    line=`sed -n "$i"p jenkins/basic.txt`
L
liuyq-617 已提交
90 91 92
    if [[ $line =~ ^./test.sh* ]] || [[ $line =~ ^run* ]]; then
			case=`echo $line | grep sim$ |awk '{print $NF}'`

93
      start_time=`date +%s`    
P
Ping Xiao 已提交
94
      date +%F\ %T | tee -a out.log
95
      if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
L
liuyq-617 已提交
96
        echo -n $case
L
fix  
liuyq-617 已提交
97
        ./test.sh -f $case > case.log 2>&1 && \
L
liuyq-617 已提交
98
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
99
        ( grep -q 'script.*success.*m$' ../../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
L
fix  
liuyq-617 已提交
100
        ( echo -e "${RED} failed${NC}" | tee -a out.log && echo '=====================log=====================' && cat case.log )
101
      else
L
liuyq-617 已提交
102
        echo -n $case
103
        ./test.sh -f $case > ../../sim/case.log 2>&1 && \
L
liuyq-617 已提交
104
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
105
        ( grep -q 'script.*success.*m$' ../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
L
fix  
liuyq-617 已提交
106
        ( echo -e "${RED} failed${NC}" | tee -a out.log && echo '=====================log=====================' &&  cat case.log )
107 108
      fi
      
L
liuyq-617 已提交
109 110
      out_log=`tail -1 out.log  `
      if [[ $out_log =~ 'failed' ]];then
L
fix  
liuyq-617 已提交
111
        rm case.log
112
        if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
L
liuyq-617 已提交
113
          cp -r ../../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S"`
114
        else 
L
liuyq-617 已提交
115
          cp -r ../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
116
        fi
L
liuyq-617 已提交
117
        dohavecore $2 1
L
fix  
liuyq-617 已提交
118 119 120
        if [[ $2 == 1 ]];then
          exit 8
        fi
L
liuyq-617 已提交
121 122 123
      fi
      end_time=`date +%s`
      echo execution time of $case was `expr $end_time - $start_time`s. | tee -a out.log
L
liuyq-617 已提交
124
      dohavecore $2 1
L
liuyq-617 已提交
125
    fi
L
liuyq-617 已提交
126
  done 
127 128
  rm -rf ../../../sim/case.log
  rm -rf ../../sim/case.log
L
liuyq-617 已提交
129
}
130 131 132 133

function runPyCaseOneByOne {
  while read -r line; do
    if [[ $line =~ ^python.* ]]; then
134
      if [[ $line != *sleep* ]]; then
L
liuyq-617 已提交
135 136 137 138 139 140
        
        if [[ $line =~ '-r' ]];then
          case=`echo $line|awk '{print $4}'`
        else
          case=`echo $line|awk '{print $NF}'`
        fi
S
Shuduo Sang 已提交
141
        start_time=`date +%s`
P
Ping Xiao 已提交
142
        date +%F\ %T | tee -a pytest-out.log
L
liuyq-617 已提交
143
        echo -n $case
144
        $line > /dev/null 2>&1 && \
L
liuyq-617 已提交
145 146
          echo -e "${GREEN} success${NC}" | tee -a pytest-out.log || \
          echo -e "${RED} failed${NC}" | tee -a pytest-out.log
S
Shuduo Sang 已提交
147
        end_time=`date +%s`
L
liuyq-617 已提交
148
        out_log=`tail -1 pytest-out.log  `
L
liuyq-617 已提交
149 150 151
        # if [[ $out_log =~ 'failed' ]];then
        #   exit 8
        # fi
S
Shuduo Sang 已提交
152
        echo execution time of $case was `expr $end_time - $start_time`s. | tee -a pytest-out.log
153 154 155
      else
        $line > /dev/null 2>&1
      fi
156 157 158
    fi
  done < $1
}
159

L
liuyq-617 已提交
160 161 162 163 164 165 166 167 168 169 170
function runPyCaseOneByOnefq() {
  cd $tests_dir/pytest
  if [[ $1 =~ full ]] ; then
    start=1
    end=`sed -n '$=' fulltest.sh`
  else
    start=`sed -n "/$1-start/=" fulltest.sh`
    end=`sed -n "/$1-end/=" fulltest.sh`
  fi
  for ((i=$start;i<=$end;i++)) ; do
    line=`sed -n "$i"p fulltest.sh`
L
liuyq-617 已提交
171 172 173 174 175 176 177 178 179
    if [[ $line =~ ^python.* ]]; then
      if [[ $line != *sleep* ]]; then
        
        if [[ $line =~ '-r' ]];then
          case=`echo $line|awk '{print $4}'`
        else
          case=`echo $line|awk '{print $NF}'`
        fi
        start_time=`date +%s`
P
Ping Xiao 已提交
180
        date +%F\ %T | tee -a pytest-out.log
L
liuyq-617 已提交
181
        echo -n $case
L
fix  
liuyq-617 已提交
182
        $line > case.log 2>&1 && \
L
liuyq-617 已提交
183
          echo -e "${GREEN} success${NC}" | tee -a pytest-out.log || \
184
          echo -e "${RED} failed${NC}" | tee -a pytest-out.log 
L
liuyq-617 已提交
185 186 187
        end_time=`date +%s`
        out_log=`tail -1 pytest-out.log  `
        if [[ $out_log =~ 'failed' ]];then
L
liuyq-617 已提交
188
          cp -r ../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
L
fix  
liuyq-617 已提交
189
          echo '=====================log===================== '
L
fix  
liuyq-617 已提交
190 191
          cat case.log
          rm -rf case.log
L
liuyq-617 已提交
192
          dohavecore $2 2
L
fix  
liuyq-617 已提交
193 194 195
          if [[ $2 == 1 ]];then
            exit 8
          fi
L
liuyq-617 已提交
196 197 198 199 200
        fi
        echo execution time of $case was `expr $end_time - $start_time`s. | tee -a pytest-out.log
      else
        $line > /dev/null 2>&1
      fi
L
liuyq-617 已提交
201
      dohavecore $2 2
L
liuyq-617 已提交
202
    fi
L
liuyq-617 已提交
203
  done 
204
  rm -rf ../../sim/case.log
L
liuyq-617 已提交
205
}
206

207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227
######################
# main entry
######################

unameOut="$(uname -s)"
case "${unameOut}" in
    Linux*)     OS=Linux;;
    Darwin*)    OS=Darwin;;
    CYGWIN*)    OS=Windows;;
    *)          OS=Unknown;;
esac

case "${OS}" in
    Linux*)     TAOSLIB=libtaos.so;;
    Darwin*)    TAOSLIB=libtaos.dylib;;
    Windows*)    TAOSLIB=taos.dll;;
    Unknown)          TAOSLIB="UNKNOWN:${unameOut}";;
esac

echo TAOSLIB is ${TAOSLIB}

228 229
totalFailed=0
totalPyFailed=0
230
totalJDBCFailed=0
P
Ping Xiao 已提交
231
totalUnitFailed=0
232
totalExampleFailed=0
sangshuduo's avatar
sangshuduo 已提交
233

234 235 236 237
if [ "${OS}" == "Linux" ]; then
    corepath=`grep -oP '.*(?=core_)' /proc/sys/kernel/core_pattern||grep -oP '.*(?=core-)' /proc/sys/kernel/core_pattern`
fi

238
if [ "$2" != "jdbc" ] && [ "$2" != "python" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ]; then
239
  echo "### run TSIM test case ###"
S
Shuduo Sang 已提交
240
  cd $tests_dir/script
241

242 243 244 245 246 247
  [ -f out.log ] && rm -f out.log
  if [ "$1" == "cron" ]; then
    echo "### run TSIM regression test ###"
    runSimCaseOneByOne regressionSuite.sim
  elif [ "$1" == "full" ]; then
    echo "### run TSIM full test ###"
P
Ping Xiao 已提交
248
    runSimCaseOneByOne jenkins/basic.txt
L
liuyq-617 已提交
249 250
  elif [ "$1" == "b1" ]; then
    echo "### run TSIM b1 test ###"
L
liuyq-617 已提交
251 252 253
    runSimCaseOneByOnefq b1 0
    runSimCaseOneByOnefq b4 0
    runSimCaseOneByOnefq b7 0
L
liuyq-617 已提交
254 255
  elif [ "$1" == "b2" ]; then
    echo "### run TSIM b2 test ###"
L
liuyq-617 已提交
256
    runSimCaseOneByOnefq b2 0
L
balance  
liuyq-617 已提交
257
    runSimCaseOneByOnefq b5 0
L
liuyq-617 已提交
258 259
  elif [ "$1" == "b3" ]; then
    echo "### run TSIM b3 test ###"
L
liuyq-617 已提交
260
    runSimCaseOneByOnefq b3 0
L
balance  
liuyq-617 已提交
261
    runSimCaseOneByOnefq b6 0
L
liuyq-617 已提交
262 263
  elif [ "$1" == "b1fq" ]; then
    echo "### run TSIM b1 test ###"
L
liuyq-617 已提交
264
    runSimCaseOneByOnefq b1 1
L
liuyq-617 已提交
265 266
  elif [ "$1" == "b2fq" ]; then
    echo "### run TSIM b2 test ###"
L
liuyq-617 已提交
267
    runSimCaseOneByOnefq b2 1
L
liuyq-617 已提交
268 269
  elif [ "$1" == "b3fq" ]; then
    echo "### run TSIM b3 test ###"
L
liuyq-617 已提交
270
    runSimCaseOneByOnefq b3 1
L
liuyq-617 已提交
271 272
  elif [ "$1" == "b4fq" ]; then
    echo "### run TSIM b4 test ###"
L
liuyq-617 已提交
273
    runSimCaseOneByOnefq b4 1
L
liuyq-617 已提交
274 275
  elif [ "$1" == "b5fq" ]; then
    echo "### run TSIM b5 test ###"
L
liuyq-617 已提交
276
    runSimCaseOneByOnefq b5 1
L
liuyq-617 已提交
277 278
  elif [ "$1" == "b6fq" ]; then
    echo "### run TSIM b6 test ###"
L
liuyq-617 已提交
279
    runSimCaseOneByOnefq b6 1
L
liuyq-617 已提交
280 281
  elif [ "$1" == "b7fq" ]; then
    echo "### run TSIM b7 test ###"
L
liuyq-617 已提交
282
    runSimCaseOneByOnefq b7 1
S
Shuduo Sang 已提交
283
  elif [ "$1" == "smoke" ] || [ -z "$1" ]; then
284 285 286
    echo "### run TSIM smoke test ###"
    runSimCaseOneByOne basicSuite.sim
  fi
287

288 289
  totalSuccess=`grep 'success' out.log | wc -l`
  totalBasic=`grep success out.log | grep Suite | wc -l`
290

291 292 293
  if [ "$totalSuccess" -gt "0" ]; then
    totalSuccess=`expr $totalSuccess - $totalBasic`
  fi
sangshuduo's avatar
sangshuduo 已提交
294

S
Shuduo Sang 已提交
295
  echo -e "\n${GREEN} ### Total $totalSuccess TSIM case(s) succeed! ### ${NC}"
296

297 298
  totalFailed=`grep 'failed\|fault' out.log | wc -l`
# echo -e "${RED} ### Total $totalFailed TSIM case(s) failed! ### ${NC}"
299

300
  if [ "$totalFailed" -ne "0" ]; then
S
Shuduo Sang 已提交
301
    echo -e "\n${RED} ### Total $totalFailed TSIM case(s) failed! ### ${NC}"
sangshuduo's avatar
sangshuduo 已提交
302

303 304
#  exit $totalFailed
  fi
sangshuduo's avatar
sangshuduo 已提交
305 306
fi

307
if [ "$2" != "sim" ] && [ "$2" != "jdbc" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ]; then
308
  echo "### run Python test case ###"
309

S
Shuduo Sang 已提交
310
  cd $tests_dir
311

S
Shuduo Sang 已提交
312
  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
313 314 315 316 317 318
    cd ../..
  else
    cd ../
  fi

  TOP_DIR=`pwd`
319
  TAOSLIB_DIR=`find . -name "${TAOSLIB}"|grep -w lib|head -n1`
320
  if [[ "$TAOSLIB_DIR" == *"$IN_TDINTERNAL"* ]]; then
321
    LIB_DIR=`find . -name "${TAOSLIB}"|grep -w lib|head -n1|cut -d '/' -f 2,3,4,5`
322
  else
323
    LIB_DIR=`find . -name "${TAOSLIB}"|grep -w lib|head -n1|cut -d '/' -f 2,3,4`
324 325 326 327
  fi

  export LD_LIBRARY_PATH=$TOP_DIR/$LIB_DIR:$LD_LIBRARY_PATH

S
Shuduo Sang 已提交
328
  cd $tests_dir/pytest
329 330 331 332 333 334 335 336 337

  [ -f pytest-out.log ] && rm -f pytest-out.log

  if [ "$1" == "cron" ]; then
    echo "### run Python regression test ###"
    runPyCaseOneByOne regressiontest.sh
  elif [ "$1" == "full" ]; then
    echo "### run Python full test ###"
    runPyCaseOneByOne fulltest.sh
L
liuyq-617 已提交
338
  elif [ "$1" == "pytest" ]; then
L
liuyq-617 已提交
339 340
    echo "### run Python full test ###"
    runPyCaseOneByOne fulltest.sh
L
liuyq-617 已提交
341 342
  elif [ "$1" == "pytestfq" ]; then
    echo "### run Python full test ###"
L
liuyq-617 已提交
343
    runPyCaseOneByOnefq full 0
344 345
  elif [ "$1" == "p1" ]; then
    echo "### run Python_1 test ###"
L
liuyq-617 已提交
346
    runPyCaseOneByOnefq p1 1
347 348
  elif [ "$1" == "p2" ]; then
    echo "### run Python_2 test ###"
L
liuyq-617 已提交
349
    runPyCaseOneByOnefq p2 1
L
liuyq-617 已提交
350 351
  elif [ "$1" == "p3" ]; then
    echo "### run Python_3 test ###"
L
liuyq-617 已提交
352
    runPyCaseOneByOnefq p3 1 
L
liuyq-617 已提交
353 354
  elif [ "$1" == "p4" ]; then
    echo "### run Python_4 test ###"
L
liuyq-617 已提交
355
    runPyCaseOneByOnefq p4 1
L
liuyq-617 已提交
356 357
  elif [ "$1" == "b2" ] || [ "$1" == "b3" ]; then
    exit $(($totalFailed + $totalPyFailed))
S
Shuduo Sang 已提交
358
  elif [ "$1" == "smoke" ] || [ -z "$1" ]; then
359 360 361
    echo "### run Python smoke test ###"
    runPyCaseOneByOne smoketest.sh
  fi
362
  totalPySuccess=`grep 'success' pytest-out.log | wc -l`
363 364

  if [ "$totalPySuccess" -gt "0" ]; then
S
Shuduo Sang 已提交
365
    echo -e "\n${GREEN} ### Total $totalPySuccess python case(s) succeed! ### ${NC}"
366 367 368 369
  fi

  totalPyFailed=`grep 'failed\|fault' pytest-out.log | wc -l`
  if [ "$totalPyFailed" -ne "0" ]; then
S
Shuduo Sang 已提交
370
    echo -e "\n${RED} ### Total $totalPyFailed python case(s) failed! ### ${NC}"
371
#  exit $totalPyFailed
372
  fi
sangshuduo's avatar
sangshuduo 已提交
373 374
fi

375

376
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ] && [ "$1" == "full" ]; then
377
  echo "### run JDBC test cases ###"
378

P
Ping Xiao 已提交
379
  cd $tests_dir
380 381 382 383 384 385 386

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

P
Ping Xiao 已提交
387
  pwd
388
  cd debug/
P
change  
Ping Xiao 已提交
389
  
P
Ping Xiao 已提交
390
  stopTaosd
391
  rm -rf /var/lib/taos/*
392 393
  nohup build/bin/taosd -c /etc/taos/ > /dev/null 2>&1 &
  sleep 30
P
change  
Ping Xiao 已提交
394
  
395
  cd $tests_dir/../src/connector/jdbc  
P
Ping Xiao 已提交
396
  
P
change  
Ping Xiao 已提交
397
  mvn test > jdbc-out.log 2>&1
398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419
  tail -n 20 jdbc-out.log

  cases=`grep 'Tests run' jdbc-out.log | awk 'END{print $3}'`
  totalJDBCCases=`echo ${cases/%,}`
  failed=`grep 'Tests run' jdbc-out.log | awk 'END{print $5}'`
  JDBCFailed=`echo ${failed/%,}`
  error=`grep 'Tests run' jdbc-out.log | awk 'END{print $7}'`
  JDBCError=`echo ${error/%,}`
  
  totalJDBCFailed=`expr $JDBCFailed + $JDBCError`
  totalJDBCSuccess=`expr $totalJDBCCases - $totalJDBCFailed`

  if [ "$totalJDBCSuccess" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalJDBCSuccess JDBC case(s) succeed! ### ${NC}"
  fi
  
  if [ "$totalJDBCFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalJDBCFailed JDBC case(s) failed! ### ${NC}"
  fi
  dohavecore 1
fi

420
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "jdbc" ]  && [ "$2" != "example" ]  && [ "$1" == "full" ]; then
421 422 423 424 425 426 427 428 429 430 431 432 433
  echo "### run Unit tests ###"  

  stopTaosd
  cd $tests_dir

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

  pwd
  cd debug/build/bin
434
  rm -rf /var/lib/taos/*
435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455
  nohup ./taosd -c /etc/taos/ > /dev/null 2>&1 &
  sleep 30
  
  pwd
  ./queryTest > unittest-out.log 2>&1
  tail -n 20 unittest-out.log

  totalUnitTests=`grep "Running" unittest-out.log | awk '{print $3}'`  
  totalUnitSuccess=`grep 'PASSED' unittest-out.log | awk '{print $4}'`
  totalUnitFailed=`expr $totalUnitTests - $totalUnitSuccess`

  if [ "$totalUnitSuccess" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalUnitSuccess Unit test succeed! ### ${NC}"
  fi
  
  if [ "$totalUnitFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalUnitFailed Unit test failed! ### ${NC}"
  fi
  dohavecore 1
fi

456 457
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "jdbc" ] && [ "$2" != "unit" ] && [ "$1" == "full" ]; then
  echo "### run Example tests ###"  
458

459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485
  stopTaosd
  cd $tests_dir

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

  pwd
  cd debug/build/bin
  rm -rf /var/lib/taos/*
  nohup ./taosd -c /etc/taos/ > /dev/null 2>&1 &
  echo "sleeping for 30 seconds"
  #sleep 30
  
  cd $tests_dir
  echo "current dir: "
  pwd
  cd examples/c
  echo "building applications"
  make > /dev/null
  totalExamplePass=0

  echo "Running tests"
  ./apitest > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
486
    echo "apitest failed"
487 488
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
489
    echo "apitest pass"
490 491 492 493 494 495 496 497 498 499 500 501 502 503
    totalExamplePass=`expr $totalExamplePass + 1`
  fi 

  ./prepare 127.0.0.1 > /dev/null 2>&1
  if [ $? != "0" ]; then
    echo "prepare failed"
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
    echo "prepare pass"
    totalExamplePass=`expr $totalExamplePass + 1`
  fi

  ./subscribe -test > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
504
    echo "subscribe failed"
505 506
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
507
    echo "subscribe pass"
508 509 510 511 512
    totalExamplePass=`expr $totalExamplePass + 1`
  fi

  yes |./asyncdemo 127.0.0.1 test 1000 10 > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
513
    echo "asyncdemo failed"
514 515
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
516
    echo "asyncdemo pass"
517 518 519 520 521 522 523 524 525 526 527
    totalExamplePass=`expr $totalExamplePass + 1`
  fi
  
  if [ "$totalExamplePass" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalExamplePass examples succeed! ### ${NC}"
  fi
  
  if [ "$totalExampleFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalExampleFailed examples failed! ### ${NC}"
  fi

528 529 530
  if [ "${OS}" == "Linux" ]; then
    dohavecore 1
  fi
531 532 533 534
fi


exit $(($totalFailed + $totalPyFailed + $totalJDBCFailed + $totalUnitFailed + $totalExampleFailed))